@echo off > nul
@title Moto X Restore Utility
cls
:start
cls
echo.
echo Welcome to the Moto X Restore Utility!
echo.
echo  1. Download latest USB Drivers. [Must be done on first run!]
echo  2. Download latest firmware. [Must be done on first run!]
echo  3. Restore Moto X [Must be done in Fastboot mode!]
echo  4. Update Utility and Tools
echo  5. Exit
echo.
echo.
set /p choice=Which option would you like to run?
if not '%choice%'== set choice=%choice:~0,1%
if '%choice%'=='1' goto :DownloadUSBDrivers
if '%choice%'=='2' goto :DownloadLatestFirmware
if '%choice%'=='3' goto :Restore
if '%choice%'=='4' goto :Update
if '%choice%'=='5' goto :exit
echo "%choice%" is not a valid option. Please try again.
echo.
goto :start

:DownloadUSBDrivers
cls
echo Downloading latest USB Driver .ZIP package to the /usbdrivers/ folder.
RD /S /Q usbdrivers\
mkdir usbdrivers\
tools\wget.exe -P usbdrivers\ http://batakang.com/ftp/MOTOX/LatestUSBDrivers.zip
echo File downloaded, extracting.
tools\unzip.exe -u usbdrivers\LatestUSBDrivers.zip -d usbdrivers\
del usbdrivers\LatestUSBDrivers.zip
cls
echo Please run the proper package (32 or 64bit) to install the correct drivers.
echo Press any key to go back to the main menu and open USB Drivers folder.
pause > nul
START usbdrivers\
cls
goto :start

:DownloadLatestFirmware
cls
echo.
echo. CURRENTLY ONLY THE BIG 4 USA CARRIERS SUPPORTED
echo Please choose the carrier variant and model of your Moto X.
echo Be completely sure it is the right one, choosing incorrectly
echo could lead to bricking your Moto X.
echo.
echo Note that this will use up to and beyond 1 GIGABYTE of space.
echo It will take a while to download depending on connection speed.
echo Also, it will overwrite any existing firmware downloaded.
echo.
echo  1. Model XT1053 - "T-Mobile USA + Retail USA + GSM DEVELOPER EDITION"
echo  2. Model XT1056 - Sprint USA
echo  3. Model XT1058 - "AT&T" USA
echo  4. Model XT1060 - Verizon USA
echo  5. Model XT1060 - Verizon DEVELOPER Edition
echo  6. Back to Main Menu.
echo.
echo.
CHOICE /N /C:123456 /M "Pick your firmware (1, 2, 3, 4, 5)"%1
IF ERRORLEVEL == 6 GOTO :start
IF ERRORLEVEL == 5 GOTO :DownloadVZWDEV
IF ERRORLEVEL == 4 GOTO :DownloadVZW
IF ERRORLEVEL == 3 GOTO :DownloadATT
IF ERRORLEVEL == 2 GOTO :DownloadSPR
IF ERRORLEVEL == 1 GOTO :DownloadTMO
goto :DownloadLatestFirmware

:DownloadTMO
cls
RD /S /Q firmware\
mkdir firmware\
cls
echo Removing old "LatestFirmware" .ZIP if it exists.
del firmware\LatestTMOFirmware.zip > nul
echo Downloading latest Model XT1053 - T-Mobile USA "&" Retail USA “&” GSM DEV .ZIP.
tools\wget.exe -P firmware\ http://batakang.com/ftp/MOTOX/LatestTMOFirmware.zip
echo File downloaded, beginning extraction.
tools\unzip.exe -u firmware\LatestTMOFirmware.zip -d firmware\
del firmware\LatestTMOFirmware.zip
cls
echo Firmware extracted to the "/firmware/" folder, run the Restore Moto X command
echo to begin to restore process. Press any key to go to the main menu.
pause > nul
copy nul firmware\version.txt
echo "T-Mobile USA + Retail USA + GSM DEVELOPER EDITION” > firmware\version.txt
cls
goto :start

:DownloadATT
cls
RD /S /Q firmware\
mkdir firmware\
cls
echo Removing old "LatestFirmware" .ZIP if it exists.
del firmware\LatestATTFirmware.zip > nul
echo Downloading latest Model XT1058 - "AT&T" USA .ZIP package to the "/firmware/" folder.
tools\wget.exe -P firmware\ http://batakang.com/ftp/MOTOX/LatestATTFirmware.zip
echo File downloaded, beginning extraction.
tools\unzip.exe -u firmware\LatestATTFirmware.zip -d firmware\
del firmware\LatestATTFirmware.zip
cls
echo Firmware extracted to the "/firmware/" folder, run the Restore Moto X command
echo to begin to restore process. Press any key to go to the main menu.
pause > nul
copy nul firmware\version.txt
echo "AT&T USA" > firmware\version.txt
cls
goto :start

:DownloadVZW
cls
RD /S /Q firmware\
mkdir firmware\
cls
echo Removing old "LatestFirmware" .ZIP if it exists.
del firmware\LatestVZWFirmware.zip > nul
echo Downloading latest Model XT1060 - Verizon USA .ZIP package to the "/firmware/" folder.
tools\wget.exe -P firmware\ http://batakang.com/ftp/MOTOX/LatestVZWFirmware.zip
echo File downloaded, beginning extraction.
tools\unzip.exe -u firmware\LatestVZWFirmware.zip -d firmware\
del firmware\LatestVZWFirmware.zip
cls
echo Firmware extracted to the "/firmware/" folder, run the Restore Moto X command
echo to begin to restore process. Press any key to go to the main menu.
pause > nul
copy nul firmware\version.txt
echo "Verizon USA" > firmware\version.txt
cls
goto :start

:DownloadVZWDEV
cls
RD /S /Q firmware\
mkdir firmware\
cls
echo Removing old "LatestFirmware" .ZIP if it exists.
del firmware\LatestVZWDEVFirmware.zip > nul
echo Downloading latest Model XT1060 - Verizon Developer Edition .ZIP package.
tools\wget.exe -P firmware\ http://batakang.com/ftp/MOTOX/LatestVZWDEVFirmware.zip
echo File downloaded, beginning extraction.
tools\unzip.exe -u firmware\LatestVZWDEVFirmware.zip -d firmware\
del firmware\LatestVZWDEVFirmware.zip
cls
echo Firmware extracted to the "/firmware/" folder, run the Restore Moto X command
echo to begin to restore process. Press any key to go to the main menu.
pause > nul
copy nul firmware\version.txt
echo "Verizon DEVELOPER EDITION” > firmware\version.txt
cls
goto :start

:DownloadSPR
cls
RD /S /Q firmware\
mkdir firmware\
cls
echo Removing old "LatestFirmware" .ZIP if it exists.
del firmware\LatestSPRFirmware.zip > nul
echo Downloading latest Model XT1056 - Sprint USA .ZIP package to the "/firmware/" folder.
tools\wget.exe -P firmware\ http://batakang.com/ftp/MOTOX/LatestSPRFirmware.zip
echo File downloaded, beginning extraction.
tools\unzip.exe -u firmware\LatestSPRFirmware.zip -d firmware\
del firmware\LatestSPRFirmware.zip
cls
echo Firmware extracted to the "/firmware/" folder, run the Restore Moto X command
echo to begin to restore process. Press any key to go to the main menu.
pause > nul
copy nul firmware\version.txt
echo "Sprint USA" > firmware\version.txt
cls
goto :start

:Restore
cls
::IF EXIST firmware\version.txt (echo. ) else goto :MissingFirmware
echo Press any key to begin flashing the firmware of..
FOR /F "tokens=*" %%i IN (firmware\version.txt) DO @ECHO %%i
echo.
echo Note that if you do not see a firmware name above this line that the utility
echo is not finding your /firmware/version.txt file. This may be because there is
echo no downloaded firmware. Please check and make sure you see files such as
echo system.IMG, boot.IMG, recovery.IMG, NON-HLOS.bin in the /firmware/ folder
echo before continuing. 
pause > nul
cls
echo.
echo  "*" WARNINGS!
echo.
echo  "*" If you flash the wrong carrier or model firmware of Moto X to your device
echo  it may become a useless brick!
echo.
echo  "*" If you flash with low battery your device may become a useless brick!
echo.
echo  "*" If you are flashing a newer version of your devices firmware, you are
echo  unlikely to be able to downgrade to a lower firmware version! This new
echo  firmware may be currently 'un-rootable' and you'll be stuck on it from then on. 
echo.
echo  "*"If you agree that everything YOU do with this is YOUR choice and YOU are
echo  taking the risk and blame if something goes wrong and acknowledge the warnings.
echo.
echo Press any key to continue.
pause > nul
cls
echo Now we must bring your Moto X into Fastboot mode. 
echo.
echo You can view a tutorial on this at www.batakang.com under Utility.
echo.
echo Press any key to continue, once your device is connected by USB and in Fastboot mode.
pause > nul
cls
echo Press any key to check if your device is detected. A string of numbers
echo will show up if it works. If no device shows up, check USB connection 
echo and USB drivers. You may need to use a USB 2.0 port.
pause > nul
echo.
echo.
echo Device number should show right below this:
tools\fastboot.exe devices
echo.
echo.
echo Hopefully you see your device here. If not, you need to fix it 
echo before we can continue.
echo.
echo If its not here, hit the X in the corner to exit this Utility.
echo.
echo If your device IS listed, hit any key to start the Restore Process.
echo.
pause > nul
cls

echo  1. Wipe everything. [including internal SD] -Recommended.-
echo  2. Do not wipe userdata/internal SD.
echo  3. Go back to the main menu.
set /p choice=Do you want to wipe fully?
if not '%choice%'== set choice=%choice:~0,1%
if '%choice%'=='1' goto :FastbootFlashWipe
if '%choice%'=='2' goto :FastbootFlashNoWipe
if '%choice%'=='3' goto :start
echo.
echo.
echo "%choice%" is not a valid option. Please try again.
echo.
goto :start

:FastbootFlashNoWipe
tools\fastboot.exe flash partition firmware/gpt.bin
tools\fastboot.exe flash motoboot firmware/motoboot.img
tools\fastboot.exe reboot-bootloader
tools\fastboot.exe flash logo firmware/logo.bin
tools\fastboot.exe flash boot firmware/boot.img
tools\fastboot.exe flash recovery firmware/recovery.img
tools\fastboot.exe flash system firmware/system.img
tools\fastboot.exe flash modem firmware/NON-HLOS.bin
tools\fastboot.exe erase modemst1
tools\fastboot.exe erase modemst1
tools\fastboot.exe flash fsg firmware/fsg.mbn
tools\fastboot.exe erase cache
tools\fastboot.exe reboot
::tools\fastboot.exe erase userdata
::tools\fastboot.exe erase customize
::tools\fastboot.exe erase clogo

:FastbootFlashWipe
tools\fastboot.exe flash partition firmware/gpt.bin
tools\fastboot.exe flash motoboot firmware/motoboot.img
tools\fastboot.exe reboot-bootloader
tools\fastboot.exe flash logo firmware/logo.bin
tools\fastboot.exe flash boot firmware/boot.img
tools\fastboot.exe flash recovery firmware/recovery.img
tools\fastboot.exe flash system firmware/system.img
tools\fastboot.exe flash modem firmware/NON-HLOS.bin
tools\fastboot.exe erase modemst1
tools\fastboot.exe erase modemst1
tools\fastboot.exe flash fsg firmware/fsg.mbn
tools\fastboot.exe erase cache
tools\fastboot.exe erase userdata
tools\fastboot.exe erase customize
tools\fastboot.exe reboot
::tools\fastboot.exe erase clogo

:MissingFirmware
cls
echo You are missing firmware to flash! Please download the firmware first with
echo the option on the main menu. Then you can return here to restore your Moto X.
echo.
echo Check your /firmware/version.txt to make sure its actually there. 
echo.
echo Press any key to return to the main menu.
pause > nul
goto :start

:Update
cls
echo Replacing Utility.bat file with latest from Batakang
echo.
tools\wget.exe -N http://batakang.com/ftp/MOTOX/RunWindowsMotoXRestoreUtility.bat
cls
echo Utility updated.
echo. 
echo.
echo Press any key to restart the utility.
pause > nul
cls
RunWindowsMotoXRestoreUtility.bat

:exit
EXIT